#ifndef BLOCKCHAIN_H
#define BLOCKCHAIN_H

#include <stdbool.h>

#include "block.h"

#define TOTAL_POINTS 5000

typedef struct _chain {
    block* head;
} chain;

chain* chain_init();
void   chain_free(chain* c);

/* add the transaction as the last element of the chain */
void   chain_add(chain* c, transaction* t);
/* check every signature of every block of the chain - true if all good, false as soon as there is one wrong */
bool   chain_validate(chain* c);
/* return an array of 5 integer containing the points of the 5 "maison" - in the order of the enum */
int*   chain_compute(chain* c);

#endif /* BLOCKCHAIN_H */
